new;
library gdr,pgraph;
gdrSet;

x = seqa(0,0.01,501);

fn cdf(x) = 1 - exp(-x);

F = cdf(x);

n = 2~5~10~15;
F_n = cdfMaximumStatistic(x,n,&cdf);

x2 = seqa(0,0.01,1001);
F_n2 = cdfMaximumStatistic(x2,n,&cdf);

xG = seqa(-3,0.01,1001);
G = cdfGumbel(xG);

x3 = seqa(0,0.01,1001);
F_n3 = cdfMaximumStatistic(x3,50,&cdf);


graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pltype = 6|1|3|6;
  _pnumht = 0.20; _paxht = 0.25;
  _pframe = 0; _plwidth = 10; _pcolor = 2|3|4|0;
  _pstype = 8; _plctrl = 0|0|0|50; _psymsiz = 4.0;

  ytics(0,1,0.2,2);
  xtics(0,5,1,2);

  setwind(1);
    xlabel("\216x");
    ylabel("\216F(x)");
    xy(x,F);

  setwind(2);
    ylabel("\216F[n](x)");
    _plegstr = "n = 2\000n = 5\000n = 10\000n = 15";
    _plegctl = {2 6 6 2};
    xy(x,F_n);

  xtics(-2,5,1,2);

  setwind(3);
    xlabel("\216x-ln(n)");
    ylabel("\216F[n](x)");
    _plegctl = {2 6 5 2};
    xy(x2-ln(N),F_n2);

  setwind(4);
    _pcolor = 2|5;
    ylabel("\216CDF");
    _plegstr = "Gumbel\000n = 50";
    xy(xG~(x3-ln(50)),G~F_n3);

    graphprt("-c=1 -cf=stress8.eps");

  endwind;