new;
library gdr,pgraph;
gdrSet;

alpha = seqa(0.10,0.10,9);

x = 0.01|seqa(1/20,1/20,19)|0.99;
y = x';
z = cdfCopulaLogisticGumbel(x,y);

xc = seqa(1/100,1/100,99) .* ones(1,9);
zc = ones(rows(xc),1) .* seqa(0.1,0.1,9)';
yc = contourCopulaLogisticGumbel(xc,zc);
data1 = packr(vecr(xc)~vecr(yc)~vecr(zc));

yc = seqa(1/100,1/100,99) .* ones(1,9);
zc = ones(rows(yc),1) .* seqa(0.1,0.1,9)';
xc = contourCopulaLogisticGumbel(yc,zc);
data2 = packr(vecr(xc)~vecr(yc)~vecr(zc));

data  = data1|data2;

u1 = 0.00001|seqa(1/200,1/200,199)|0.99999;
u2 = contourCopulaLogisticGumbel(u1,alpha');

C1 = cdfCopulaProduct2(u1,u2);
C2 = cdfCopulaUpper2(u1,u2);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pframe = 0; _pnum = 2; _pltype = 6|3;
  _pnumht = 0.20; _paxht = 0.25; _plwidth = 10; _pcolor = 2|0|4|5|1|3|6|7|8;
  xtics(0,1,0.2,2); ytics(0,1,0.2,2); ztics(0,1,0.2,2);
  xlabel("\216u]1["); ylabel("\216u]2[ = \202f]a[\201(u]1[)"); zlabel("\216C(u]1[,u]2[)");

  setwind(1);
    _pmsgstr = MakeMsgStr(ftocv(alpha,0,2));
    _pmsgctl = (2*alpha./(1+alpha)~2*alpha./(1+alpha))-(0.025~0.025)~ones(9,1).*(0.175~0~1~0~6);
    xy(u1,u2);

  setwind(2);
    _psym3d = data~ones(rows(data),1).*(8~0.5~2~5) ;
    _pmsgstr = MakeMsgStr(ftocv(alpha,0,2));
    _pmsgctl = { 4.85 1.35 0.175 0 2 0 6,
                 4.80 2.15 0.175 0 2 0 6,
                 4.75 2.92 0.175 0 2 0 6,
                 4.70 3.58 0.175 0 2 0 6,
                 4.65 4.20 0.175 0 2 0 6,
                 4.60 4.75 0.175 0 2 0 6,
                 4.55 5.27 0.175 0 2 0 6,
                 4.50 5.79 0.175 0 2 0 6,
                 4.45 6.29 0.175 0 2 0 6};
    _pzclr = 4;
    surface(y,x,z);

   _pmsgctl = 0;

  setwind(3);
    ylabel("\216C[\202\74\201](u]1[,\202f]a[\201(u]1[))");
    xy(u1,C1);

  setwind(4);
    ylabel("\216C[+](u]1[,\202f]a[\201(u]1[))");
    xy(u1,C2);

    graphprt("-c=1 -cf=sklar4.eps");

  endwind;